Attribute VB_Name = "MdlCalcDec"
'---------------------------------------------------------------------------------------
' Module    : MdlCalcDec
' Author    : Nicolas
' Purpose   : Module de calcul dcimal
'---------------------------------------------------------------------------------------
Public Function AddNb(ByVal Nb1 As String, ByVal Nb2 As String) As String
'---------------------------------------------------------------------------------------
' Procedure : Add
' Author    : Nicolas
' Purpose   : Additionne 2 nombres
'---------------------------------------------------------------------------------------
Dim Tmp As String
Dim Retenue As Long
Dim i As Long
Dim c1 As Long
Dim c2 As Long
On Local Error GoTo Err_Add
    If Len(Nb1) > Len(Nb2) Then
        Nb2 = Right$(String(Len(Nb1), "0") + Nb2, Len(Nb1))
    ElseIf Len(Nb1) < Len(Nb2) Then
        Nb1 = Right$(String(Len(Nb2), "0") + Nb1, Len(Nb2))
    End If
    
    For i = Len(Nb1) To 1 Step -1
        c1 = Val(Mid$(Nb1, i, 1))
        c2 = Val(Mid$(Nb2, i, 1))
        Tmp = Right$(Format$(Retenue + c1 + c2), 1) + Tmp
        Retenue = Int((Retenue + c1 + c2) / 10)
    Next
    If Retenue > 0 Then Tmp = Format$(Retenue) + Tmp
    Do While Left$(Tmp, 1) = "0": Tmp = Right$(Tmp, Len(Tmp) - 1): Loop
    AddNb = Tmp
Exit Function
Err_Add:
    AddNb = "0"
    Err.Clear
End Function
Public Function MultNb(ByVal Nb1 As String, ByVal Nb2 As String) As String
'---------------------------------------------------------------------------------------
' Procedure : MultNb
' Author    : Nicolas
' Purpose   : Multiplication de 2 nombres
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_MultNb
Dim Tmp As String
Dim Tmp1 As String
Dim i As Long
Dim j As Long
Dim d As Long
Dim c As Long
    
    Tmp = 0
    For i = Len(Nb1) To 1 Step -1
        Tmp1 = 0
        d = Len(Nb1) - i
        c = Val(Mid$(Nb1, i, 1))
        
        For j = 1 To c
            Tmp1 = AddNb(Tmp1, Nb2)
        Next
        Tmp = AddNb(Tmp, Tmp1 + String$(d, "0"))
    Next
    
    Do While Left$(Tmp, 1) = "0": Tmp = Right$(Tmp, Len(Tmp) - 1): Loop
    If Tmp = "" Then Tmp = "0"
    MultNb = Tmp
Exit Function
Err_MultNb:
    MultNb = "0"
    Err.Clear
End Function
Public Function SousNb(ByVal Nb1 As String, ByVal Nb2 As String) As String
'---------------------------------------------------------------------------------------
' Procedure : SousNb
' Author    : Nicolas
' Purpose   : Soustraction de 2 nombres (Nb1-Nb2)
'---------------------------------------------------------------------------------------
Dim Tmp As String
Dim Retenue As Long
Dim i As Long
Dim c1 As Long
Dim c2 As Long
Dim a As Long
Dim b As Long
On Local Error GoTo Err_SousNb
    If Len(Nb1) > Len(Nb2) Then
        Nb2 = Right$(String(Len(Nb1), "0") + Nb2, Len(Nb1))
    ElseIf Len(Nb1) < Len(Nb2) Then
        Nb1 = Right$(String(Len(Nb2), "0") + Nb1, Len(Nb2))
    End If
    
    For i = Len(Nb1) To 1 Step -1
        c1 = Val(Mid$(Nb1, i, 1))
        c2 = Val(Mid$(Nb2, i, 1)) + Retenue
        a = c1 - c2
        If a < 0 Then
            c1 = c1 + 10
            Retenue = 1
            a = c1 - c2
        Else
            Retenue = 0
        End If
        Tmp = Format$(a) + Tmp
    Next
    Do While Left$(Tmp, 1) = "0": Tmp = Right$(Tmp, Len(Tmp) - 1): Loop
    If Tmp = "" Then Tmp = "0"
    SousNb = Tmp
Exit Function
Err_SousNb:
    SousNb = "0"
    Err.Clear
End Function
Public Function DivNb(ByVal Nb1 As String, ByVal Nb2 As String) As String
'---------------------------------------------------------------------------------------
' Procedure : DivNb
' Author    : Nicolas
' Purpose   : Div de Nb1/Nb2
'---------------------------------------------------------------------------------------
Dim Tmp As String
Dim Tmp1 As String
Dim Tmp2 As String
Dim i As Long
Dim j As Long
On Local Error GoTo Err_DivNb
    
    Nb2 = DelZero(Nb2)
    Nb1 = DelZero(Nb1)
    
    If Len(Nb1) < Len(Nb2) Then
        DivNb = 0
        Exit Function
    End If
    
    i = 0
    Tmp2 = ""
    Do While i < Len(Nb1)
        i = i + 1
        Tmp2 = DelZero(Tmp2 + Mid$(Nb1, i, 1))
        j = 0
        Do While NbSup(Tmp2, Nb2) Or NbEq(Tmp2, Nb2)
            j = j + 1
            Tmp2 = SousNb(Tmp2, Nb2)
        Loop
        Tmp = Tmp + Format$(j)
    Loop
    Tmp = DelZero(Tmp)
    DivNb = Tmp
Exit Function
Err_DivNb:
    DivNb = "0"
    Err.Clear
End Function
Public Function Reste(ByVal Nb1 As String, ByVal Nb2 As String) As String
'---------------------------------------------------------------------------------------
' Procedure : Reste
' Author    : Nicolas
' Purpose   : Donne le reste d'une division
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_Reste
    a = DivNb(Nb1, Nb2)
    b = MultNb(a, Nb2)
    Reste = SousNb(Nb1, b)
Exit Function
Err_Reste:
    Reste = 0
    Err.Clear
End Function

Public Function DelZero(ByVal Ch As String) As String
    Do While Left$(Ch, 1) = "0": Ch = Right$(Ch, Len(Ch) - 1): Loop
    DelZero = Ch
End Function

Public Function NbSup(ByVal Nb1 As String, ByVal Nb2 As String) As Boolean
'---------------------------------------------------------------------------------------
' Procedure : NbSup
' Author    : Nicolas
' Purpose   : Vrai si Nb1>Nb2
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_NbSup
    Nb1 = DelZero(Nb1)
    Nb2 = DelZero(Nb2)
    
    If Len(Nb1) > Len(Nb2) Then
        NbSup = True
        Exit Function
    ElseIf Len(Nb1) < Len(Nb2) Then
        NbSup = False
        Exit Function
    End If
    
    For i = 1 To Len(Nb1)
        c1 = Val("&h" + Mid$(Nb1, i, 1))
        c2 = Val("&h" + Mid$(Nb2, i, 1))
        
        If c1 > c2 Then
            NbSup = True
            Exit Function
        ElseIf c1 < c2 Then
            NbSup = False
            Exit Function
        End If
    Next
    
    NbSup = False
Exit Function
Err_NbSup:
    NbSup = 0
    Err.Clear
End Function

Public Function NbEq(ByVal Nb1 As String, ByVal Nb2 As String) As Boolean
'---------------------------------------------------------------------------------------
' Procedure : NbEq
' Author    : Nicolas
' Purpose   :
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_NbEq
    Nb1 = DelZero(Nb1)
    Nb2 = DelZero(Nb2)
    NbEq = (Nb1 = Nb2)
Exit Function
Err_NbEq:
    NbEq = False
    Err.Clear
End Function

