Attribute VB_Name = "MdlConvert"
'---------------------------------------------------------------------------------------
' Module    : MdlConvert
' Author    : Nicolas
' Purpose   : Module de Conversion
'---------------------------------------------------------------------------------------

Public Function CnvDecHex(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvDecHex
' Author    : Nicolas
' Purpose   : Conversions Dcimal -> Hexadcimal
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvDecHex
Dim Num As String
Dim Tmp As String
    
    Nb = DelCars(Nb, "0123456789")
    
    Tmp = ""
    
    Do
        Num = Reste(Nb, 16)
        Tmp = Hex$(Val(Num)) + Tmp
        Nb = DivNb(Nb, 16)
'        Tmp = Hex$(Num Mod 16) + Tmp
'        Num = Int(Num / 16)
    Loop While Nb <> "0" And Nb <> ""
    
    CnvDecHex = Tmp
    
Exit Function
Err_CnvDecHex:
    CnvDecHex = " Dec->Hex, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvHexHex(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvHexHex
' Author    : Nicolas
' Purpose   : Conversions Hexa -> Hexa
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_cnvHexHex
    
Dim Num As Currency
Dim Tmp As String
Dim i As Long
    
    Nb = DelCars(UCase$(Nb), "0123456789ABCDEF")
    
    CnvHexHex = Nb
    
Exit Function
Err_cnvHexHex:
    CnvHexHex = " Hex->Hex, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvBinHex(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvBinHex
' Author    : Nicolas
' Purpose   : Conversions Binaire -> Hexadcimal
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_cnvBinHex
    
Dim Tmp As String
Dim i As Long
    
    Nb = DelCars(Nb, "01")
    
    Do While Len(Nb) Mod 4 <> 0: Nb = "0" + Nb: Loop
    
    Tmp = ""
    
    For i = 0 To (Len(Nb) / 4) - 1
        c = Mid$(Nb, i * 4 + 1, 4)
        Select Case c
            Case "0000": c = "0"
            Case "0001": c = "1"
            Case "0010": c = "2"
            Case "0011": c = "3"
            Case "0100": c = "4"
            Case "0101": c = "5"
            Case "0110": c = "6"
            Case "0111": c = "7"
            Case "1000": c = "8"
            Case "1001": c = "9"
            Case "1010": c = "A"
            Case "1011": c = "B"
            Case "1100": c = "C"
            Case "1101": c = "D"
            Case "1110": c = "E"
            Case "1111": c = "F"
        End Select
        Tmp = Tmp + c
    Next
    
    CnvBinHex = Tmp
Exit Function
Err_cnvBinHex:
    CnvBinHex = " Bin->Hex, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvBcdHex(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvBcdHex
' Author    : Nicolas
' Purpose   : Conversion BCD -> Dcimal -> Hexadcimal
'---------------------------------------------------------------------------------------
    Nb = CnvBinHex(Nb)
    If Left$(Nb, 1) <> " " Then Nb = CnvDecHex(Nb)
    CnvBcdHex = Nb
End Function
Public Function CnvOctHex(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvOctHex
' Author    : Nicolas
' Purpose   : Conversion Octal -> Binaire -> Hexadcimal
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvOctHex
Dim Tmp As String
    
    Nb = DelCars(Nb, "01234567")
    
    For i = 1 To Len(Nb)
        c = Mid$(Nb, i, 1)
        Select Case c
            Case "0": c = "000"
            Case "1": c = "001"
            Case "2": c = "010"
            Case "3": c = "011"
            Case "4": c = "100"
            Case "5": c = "101"
            Case "6": c = "110"
            Case "7": c = "111"
        End Select
        Tmp = Tmp + c
    Next
    
    CnvOctHex = CnvBinHex(Tmp)
Exit Function
Err_CnvOctHex:
    CnvOctHex = " Oct->Hex, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvGraHex(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvGraHex
' Author    : Nicolas
' Purpose   : Conversion Binaire rflchi -> Hexadcimal
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvGraHex
Dim Tmp As String
    
'    CnvGraHex = " Selection non implmente"
'    Exit Function
    Nb = "0" + Nb
    Tmp = "0"
    For i = 2 To Len(Nb)
        Tmp = Tmp + Format$((Val(Mid$(Tmp, i - 1, 1))) Xor Val(Mid$(Nb, i, 1)))
    Next
    CnvGraHex = CnvBinHex(Tmp)
Exit Function
Err_CnvGraHex:
    CnvGraHex = " Gra->Hex, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvCarHex(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvCarHex
' Author    : Nicolas
' Purpose   : Converti chaque caractre en son quivalant hexadcimal
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvCarHex
Dim Tmp As String
    For i = 1 To Len(Nb)
        c = Mid$(Nb, i, 1)
        Tmp = Tmp + Right$("00" + Hex$(Asc(c)), 2)
    Next
    CnvCarHex = Tmp
Exit Function
Err_CnvCarHex:
    CnvCarHex = " Car->Hex, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function

Private Function DelCars(ByVal Ch As String, ByVal Filter As String) As String
Dim Tmp As String
    
    For i = 1 To Len(Ch)
        c = Mid$(Ch, i, 1)
        If InStr(Filter, c) <> 0 Then
            Tmp = Tmp + c
        End If
    Next
    
    DelCars = Tmp
End Function

Public Function CnvHexDec(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvHexDec
' Author    : Nicolas
' Purpose   : Conversion Hex -> dec
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvHexDec
Dim Tmp As String
Dim Tmp1 As String
    Tmp = "0"
    For i = 1 To Len(Nb)
        Tmp1 = MultNb(Tmp, 16)
        Tmp = AddNb(Tmp1, Val("&h" + Mid$(Nb, i, 1)))
    Next
    
    CnvHexDec = Tmp
Exit Function
Err_CnvHexDec:
    CnvHexDec = " Hex->Dec, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvHexBin(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvHexBin
' Author    : Nicolas
' Purpose   : Conversion Hex -> Bin
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvHexBin
Dim Tmp As String
    
    For i = 1 To Len(Nb)
        c = Mid(Nb, i, 1)
        Select Case c
            Case "0": c = "0000"
            Case "1": c = "0001"
            Case "2": c = "0010"
            Case "3": c = "0011"
            Case "4": c = "0100"
            Case "5": c = "0101"
            Case "6": c = "0110"
            Case "7": c = "0111"
            Case "8": c = "1000"
            Case "9": c = "1001"
            Case "A": c = "1010"
            Case "B": c = "1011"
            Case "C": c = "1100"
            Case "D": c = "1101"
            Case "E": c = "1110"
            Case "F": c = "1111"
        End Select
        Tmp = Tmp + c
    Next
    
    Do While Left$(Tmp, 1) = "0": Tmp = Right$(Tmp, Len(Tmp) - 1): Loop
    
    CnvHexBin = Tmp
Exit Function
Err_CnvHexBin:
    CnvHexBin = " Hex->Bin, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvHexBcd(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvHexBcd
' Author    : Nicolas
' Purpose   : Conversion Hex -> Dec -> BCD
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvHexBcd
Dim Tmp As String
    Tmp = CnvHexDec(Nb)
    
    If Left$(Tmp, 1) <> " " Then
        Nb = Tmp
        Tmp = ""
        For i = 1 To Len(Nb)
            c = Mid$(Nb, i, 1)
            Select Case c
                Case "0": c = "0000"
                Case "1": c = "0001"
                Case "2": c = "0010"
                Case "3": c = "0011"
                Case "4": c = "0100"
                Case "5": c = "0101"
                Case "6": c = "0110"
                Case "7": c = "0111"
                Case "8": c = "1000"
                Case "9": c = "1001"
            End Select
            Tmp = Tmp + c
        Next
    End If
    
    CnvHexBcd = Tmp
Exit Function
Err_CnvHexBcd:
    CnvHexBcd = " Hex->BCD, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvHexOct(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvHexOct
' Author    : Nicolas
' Purpose   : Conversion Hex -> Oct
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvHexOct
Dim Tmp As String
    Tmp = CnvHexBin(Nb)
    If Left$(Tmp, 1) <> " " Then
        Nb = Tmp
        Tmp = ""
        Do While (Len(Nb) Mod 3) <> 0: Nb = "0" + Nb: Loop
        For i = 0 To Len(Nb) / 3 - 1
            c = Mid$(Nb, i * 3 + 1, 3)
            Select Case c
                Case "000": c = "0"
                Case "001": c = "1"
                Case "010": c = "2"
                Case "011": c = "3"
                Case "100": c = "4"
                Case "101": c = "5"
                Case "110": c = "6"
                Case "111": c = "7"
            End Select
            Tmp = Tmp + c
        Next
    End If
    CnvHexOct = Tmp
Exit Function
Err_CnvHexOct:
    CnvHexOct = " Hex->Oct, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvHexGra(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvHexGra
' Author    : Nicolas
' Purpose   : Conversion Hex -> Binaire rflchi
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvHexGra
Dim Tmp As String
    Tmp = CnvHexBin(Nb)
    If Left$(Tmp, 1) <> " " Then
        Nb = "0" + Tmp
        Tmp = ""
        For i = 2 To Len(Nb)
            Tmp = Tmp + Format$(Val(Mid$(Nb, i - 1, 1)) Xor Val(Mid$(Nb, i, 1)))
        Next
    End If
    CnvHexGra = Tmp
Exit Function
Err_CnvHexGra:
    CnvHexGra = " Hex->Gra, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
Public Function CnvHexCar(ByVal Nb As String) As String
'---------------------------------------------------------------------------------------
' Procedure : CnvHexCar
' Author    : Nicolas
' Purpose   : Conversion Hex -> String
'---------------------------------------------------------------------------------------
On Local Error GoTo Err_CnvHexCar
Dim Tmp As String
    Do While (Len(Nb) Mod 2) = 1: Nb = "0" + Nb: Loop
    For i = 0 To Len(Nb) / 2 - 1
        c = Mid$(Nb, i * 2 + 1, 2)
        Tmp = Tmp + Chr$(Val("&h" + c))
    Next
    CnvHexCar = Tmp
Exit Function
Err_CnvHexCar:
    CnvHexCar = " Hex->Car, Erreur #" & Err & ", " & Err.Description
    Err.Clear
End Function
